#include <iostream>
#include <time.h>
#include "data_functions.h"

void work_with_vector()
{
	std::vector<int> vec;
	std::string f_name("mifilo.txt");
	bool is_still_running = true;
	int option;

	while (is_still_running)
	{
		std::cout << std::endl << "Choose function:" << std::endl
			<< "1)createData_fstreams" << std::endl
			<< "2)createData_fstream_iterators" << std::endl
			<< "3)loadData_fstreams" << std::endl
			<< "4)loadData_fstream_iterators" << std::endl
			<< "5)container_printout" << std::endl
			<< "6)Modify_regular" << std::endl
			<< "7)Modify_iterators" << std::endl
			<< "8)Modify_for_each" << std::endl
			<< "9)Modify_transform" << std::endl
			<< "10)outputResult_fstreams" << std::endl
			<< "11)outputResult_copy" << std::endl
			<< "12)Change container type" << std::endl << "->  ";

		std::cin >> option;

		std::cout << std::endl;

		switch (option)
		{
		case 1:
			createData_fstreams(f_name);
			break;
		case 2:
			createData_fstream_iterators <std::vector<int>>(f_name);
			break;
		case 3:
			vec = std::move(loadData_fstreams<std::vector<int>>(f_name));
			break;
		case 4:
			vec = std::move(loadData_fstream_iterators<std::vector<int>>(f_name));
			break;
		case 5:
			container_printout<std::vector<int>>(vec);
			break;
		case 6:
			Modify_regular<std::vector<int>>(vec);
			break;
		case 7:
			Modify_iterators<std::vector<int>::iterator>(vec.begin(), vec.end());
			break;
		case 8:
			Modify_for_each<std::vector<int>>(vec);
			break;
		case 9:
			Modify_transform<std::vector<int>>(f_name);
			break;
		case 10:
			outputResult_fstreams<std::vector<int>>(vec, f_name);
			break;
		case 11:
			outputResult_copy<std::vector<int>>(vec, f_name);
			break;
		case 12:
			is_still_running = false;
			break;
		default:
			std::cout << "invalid option" << std::endl;
			break;
		}

	}
}

void work_with_list()
{
	std::list<int> listt;
	std::string f_name("mifilo.txt");
	bool is_still_running = true;
	int option;

	while (is_still_running)
	{
		std::cout << std::endl << "Choose function:" << std::endl
			<< "1)createData_fstreams" << std::endl
			<< "2)createData_fstream_iterators" << std::endl
			<< "3)loadData_fstreams" << std::endl
			<< "4)loadData_fstream_iterators" << std::endl
			<< "5)container_printout" << std::endl
			<< "6)Modify_regular" << std::endl
			<< "7)Modify_iterators" << std::endl
			<< "8)Modify_for_each" << std::endl
			<< "9)Modify_transform" << std::endl
			<< "10)outputResult_fstreams" << std::endl
			<< "11)outputResult_copy" << std::endl
			<< "12)Change container type" << std::endl << "->  ";

		std::cin >> option;

		std::cout << std::endl;

		switch (option)
		{
		case 1:
			createData_fstreams(f_name);
			break;
		case 2:
			createData_fstream_iterators<std::list<int>>(f_name);
			break;
		case 3:
			listt = std::move(loadData_fstreams<std::list<int>>(f_name));
			break;
		case 4:
			listt = std::move(loadData_fstream_iterators<std::list<int>>(f_name));
			break;
		case 5:
			container_printout<std::list<int>>(listt);
			break;
		case 6:
			Modify_regular<std::list<int>>(listt);
			break;
		case 7:
			Modify_iterators<std::list<int>::iterator>(listt.begin(), listt.end());
			break;
		case 8:
			Modify_for_each<std::list<int>>(listt);
			break;
		case 9:
			Modify_transform<std::list<int>>(f_name);
			break;
		case 10:
			outputResult_fstreams<std::list<int>>(listt, f_name);
			break;
		case 11:
			outputResult_copy<std::list<int>>(listt, f_name);
			break;
		case 12:
			is_still_running = false;
			break;
		default:
			std::cout << "invalid option" << std::endl;
			break;
		}

	}
}

void work_with_deque()
{
	std::deque<int> deq;
	std::string f_name("mifilo.txt");
	bool is_still_running = true;
	int option;

	while (is_still_running)
	{
		std::cout << std::endl << "Choose function:" << std::endl
			<< "1)createData_fstreams" << std::endl
			<< "2)createData_fstream_iterators" << std::endl
			<< "3)loadData_fstreams" << std::endl
			<< "4)loadData_fstream_iterators" << std::endl
			<< "5)container_printout" << std::endl
			<< "6)Modify_regular" << std::endl
			<< "7)Modify_iterators" << std::endl
			<< "8)Modify_for_each" << std::endl
			<< "9)Modify_transform" << std::endl
			<< "10)outputResult_fstreams" << std::endl
			<< "11)outputResult_copy" << std::endl
			<< "12)Change container type" << std::endl << "->  ";

		std::cin >> option;

		std::cout << std::endl;

		switch (option)
		{
		case 1:
			createData_fstreams(f_name);
			break;
		case 2:
			createData_fstream_iterators<std::deque<int>>(f_name);
			break;
		case 3:
			deq = std::move(loadData_fstreams<std::deque<int>>(f_name));
			break;
		case 4:
			deq = std::move(loadData_fstream_iterators<std::deque<int>>(f_name));
			break;
		case 5:
			container_printout<std::deque<int>>(deq);
			break;
		case 6:
			Modify_regular<std::deque<int>>(deq);
			break;
		case 7:
			Modify_iterators<std::deque<int>::iterator>(deq.begin(), deq.end());
			break;
		case 8:
			Modify_for_each<std::deque<int>>(deq);
			break;
		case 9:
			Modify_transform<std::deque<int>>(f_name);
			break;
		case 10:
			outputResult_fstreams<std::deque<int>>(deq, f_name);
			break;
		case 11:
			outputResult_copy<std::deque<int>>(deq, f_name);
			break;
		case 12:
			is_still_running = false;
			break;
		default:
			std::cout << "invalid option" << std::endl;
			break;
		}

	}
}


int run()
{
	bool is_still_running = true;
	int option;

	while (is_still_running)
	{
		std::cout << std::endl << "Choose container type to work with:" << std::endl
			<< "1)std::Vector" << std::endl
			<< "2)std::List" << std::endl
			<< "3)std::Deque" << std::endl
			<< "4)Exit" << std::endl << "->  ";

		std::cin >> option;

		std::cout << std::endl;

		switch (option)
		{
		case 1:
			work_with_vector();
			break;
		case 2:
			work_with_list();
			break;
		case 3:
			work_with_deque();
			break;
		case 4:
			is_still_running = false;
			break;
		default:
			std::cout << "invalid option" << std::endl;
			break;
		}

	}
	return 1;
}

int main()
{
	srand(time(NULL));
	return run();
}
