#include <iostream>
#include <string>
#include <fstream>
#include <iterator>
#include <algorithm>
#include <vector>
#include <list>
#include <deque>
#include <functional>
#include <iomanip>
#include <math.h>

class GenerateFunctor
{

public:

	int operator ()()
	{
		return ((rand() % 101) - 50);
	}
};

class MultiplyFunctor
{
private:

	int cl_toMul;

public:

	MultiplyFunctor(int p_toMul) :
		cl_toMul(p_toMul)
	{}

	int operator ()(const int p_toTr) const //!!! Фундаментальные типы НЕТ СМСЫСЛА ПЕРЕДАВАТЬ ПО ССЫЛКЕ->Исправлено
	{
		return p_toTr * cl_toMul;
	}


};

template<class Container> //!!! Зачем передавать Container_iterator?->Исправлено
void container_printout(const Container& p_cont)
{
	std::cout << "_____" << std::endl;
	unsigned int count = 1;
	

	std::for_each(p_cont.begin(), p_cont.end(), [&count](int p_elem) {
		std::cout << std::setw(4) << count << ")  " << std::setw(8) << p_elem << std::endl;
		count++;
		});

	
	std::cout << "_____" << std::endl << std::endl;
}


void createData_fstreams(const std::string& p_file_name)
{
	std::ofstream Fstr_out(p_file_name);

	for (int i = 0; i < 100; i++)
	{
		Fstr_out << ((rand() % 101) - 50) << "\n";
	}

	Fstr_out.close();
}


template<typename Container>
void createData_fstream_iterators(const std::string& p_file_name)
{
	std::ofstream Fstr_out(p_file_name);
	 //!!! Все методы не должны зависеть от типа контейнера.->Исправлено
	using Value_type = typename Container::value_type;
	Container cont(100);
	GenerateFunctor gen_fc;
	std::generate(cont.begin(), cont.end(), gen_fc);
	std::copy(cont.begin(), cont.end(), std::ostream_iterator<Value_type>(Fstr_out, "\n"));
	Fstr_out.close();
}


template<class Container>
Container loadData_fstreams(const std::string& p_file_name)
{
	Container result_cont;
	std::ifstream Fstr_in(p_file_name);

	if (!Fstr_in.is_open())
	{
		throw std::exception("Wrong file name");
	}

	int just_read;

	while (Fstr_in >> just_read)
	{
		result_cont.push_back(just_read);
	}

	Fstr_in.close();

	return result_cont;
}


template<class Container>
Container loadData_fstream_iterators(const std::string& p_file_name)
{
	Container result_cont;
	std::ifstream Fstr_in(p_file_name);

	if (!Fstr_in.is_open())
	{
		throw std::exception("Wrong file name");
	}

	using Value_type = typename Container::value_type;
	std::istream_iterator<Value_type> fst(Fstr_in);
	std::istream_iterator<Value_type> lst;

	result_cont.resize(100);
	std::copy(fst, lst, result_cont.begin());
	Fstr_in.close();

	return result_cont;
}


template<class Container>
bool Modify_regular(Container& p_container)
{
	if (p_container.size() == 0)
	{
		return true;
	}


    //!!! Несмотря на задание, функции не должны зависеть от конкретных типов->Исправлено
	 using Value_type = typename Container::value_type;
	 Value_type minimal = *std::min_element(p_container.begin(), p_container.end());
	 Value_type summ = 0;
	 Value_type abs_summ = 0;
	

	std::for_each(p_container.begin(), p_container.end(), [&summ, &abs_summ](const auto &p_elem) {
		abs_summ += abs(p_elem);
		summ += p_elem;
		});



	auto container_iterator = p_container.begin();

	while (container_iterator != p_container.end())
	{
		*container_iterator *= minimal;
		container_iterator++;
	}

	p_container.push_back(summ);
	p_container.push_back(abs_summ / p_container.size());

	return true;
}

template<class Container>
bool Modify_iterators(Container p_iter_beg, Container p_iter_end)
{
	if (p_iter_beg == p_iter_end)
	{
		return true;
	}

	//!!! Несмотря на задание, функции не должны зависеть от конкретных типов->Исправлено
	using Value_type = typename Container::value_type;
	Value_type minimal = *std::min_element(p_iter_beg, p_iter_end);

	
	std::for_each(p_iter_beg, p_iter_end, [minimal](auto& p_num)
		{
			p_num *= minimal;
		});
	
	return true;
}

template<class Container>
bool Modify_for_each(Container& p_container)
{
	if (p_container.size() == 0)
	{
		return true;
	}

    //!!! Несмотря на задание, функции не должны зависеть от конкретных типов->Исправлено
	using Value_type = typename Container::value_type;
	Value_type minimal = *std::min_element(p_container.begin(), p_container.end());
	auto p_cont_iter = p_container.begin();
	p_cont_iter++;

	std::for_each(p_container.begin(), p_container.end(), [minimal](auto& p_num)
		{
			p_num *= minimal;
		});

	return true;
}


template<typename Container>
bool Modify_transform(const std::string& p_file_name)
{
	std::ifstream Fstr_in(p_file_name);

	if (!Fstr_in.is_open())
	{
		return false;
	}

	using Value_type = typename Container::value_type;
	Value_type minimal = 0;//!!! Несмотря на задание, функции не должны зависеть от конкретных типов->ИСПРАВЛЕНО
	Value_type cur_num;//!!! Несмотря на задание, функции не должны зависеть от конкретных типов->ИСПРАВЛЕНО

	if (!Fstr_in >> minimal)
	{
		return true;
	}

	while (Fstr_in >> cur_num)
	{
		if (minimal > cur_num)
		{
			minimal = cur_num;
		}
	}

	MultiplyFunctor fnc(minimal);
	Fstr_in.close();
	Fstr_in.open(p_file_name);
	std::ofstream Fstr_out("res.txt");
	std::transform(std::istream_iterator<Value_type>(Fstr_in), std::istream_iterator<Value_type>(), std::ostream_iterator<Value_type>(Fstr_out, "\n"), fnc);

	Fstr_in.close();
	Fstr_out.close();

	return true;
}

template<class Container>
bool outputResult_fstreams(const Container& p_container, const std::string& p_file_name)
{
	std::ofstream Fstr_out(p_file_name);
	if (!Fstr_out.is_open())
	{
		return false;
	}

	std::for_each(p_container.begin(), p_container.end(), [&Fstr_out](int p_num) {
		Fstr_out << p_num << "\n";
		});

	Fstr_out.close();
	return true;
}

template<class Container>
bool outputResult_copy(const Container& p_container, const std::string& p_file_name)
{
	std::ofstream Fstr_out(p_file_name);

	if (!Fstr_out.is_open())
	{
		return false;
	}

	using Value_type = typename Container::value_type;
	std::copy(p_container.begin(), p_container.end(), std::ostream_iterator<Value_type>(Fstr_out, "\n"));
	Fstr_out.close();
	return true;
}

template<class Container>
bool Modify_in_place(const std::string& p_file_name)
{
	std::ifstream Fstr_in(p_file_name);

	if (!Fstr_in.is_open())
	{
		return false;
	}

	using Value_type = typename Container::value_type;
	Value_type minimal = 0;//!!! Несмотря на задание, функции не должны зависеть от конкретных типов->ИСПРАВЛЕНО
	Value_type cur_num;//!!! Несмотря на задание, функции не должны зависеть от конкретных типов->ИСПРАВЛЕНО

	if (!Fstr_in >> minimal)
	{
		return true;
	}

	while (Fstr_in >> cur_num)
	{
		if (minimal > cur_num)
		{
			minimal = cur_num;
		}
	}

	Fstr_in.close();
	Fstr_in.open(p_file_name);

	MultiplyFunctor fnc(minimal);
	
	std::ofstream Fstr(p_file_name); //!!! Зачем файл открывать на чтение и запись?->Исправлено
	
	if (!Fstr.is_open())
	{
		return false;
	}

	std::transform(std::istream_iterator<Value_type>(Fstr_in), std::istream_iterator<Value_type>(), std::ostream_iterator<int>(Fstr, "\n"), fnc);

	Fstr_in.close();
	Fstr.close();

	return true;
}